/// Project to reproduce the issue 0006037: Writing to TJvListview.ItemIndex act differently from TListview
/// http://issuetracker.delphi-jedi.org/view.php?id=6037
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, JvTimer, ComCtrls, JvExComCtrls, JvListView, JvExControls, JvLED,
  StdCtrls;

type
  TForm1 = class(TForm)
    JvListView1: TJvListView;
    JvTimer1: TJvTimer;
    JvLED1: TJvLED;
    ListView1: TListView;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure JvTimer1Timer(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateListView(const AListView : TListView);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// The timer will fire every 3 seconds.
procedure TForm1.JvTimer1Timer(Sender: TObject);
begin
  // Update the TJvListView : selected item is not restored !
  UpdateListView(JvListView1);
  // Update TListview : It works !
  UpdateListView(ListView1);

  JvLED1.Status := not JvLED1.Status;
end;

procedure TForm1.UpdateListView(const AListView: TListView);
var
  SavedItemIndex : integer;
  IndexLines: Integer;
begin
  // Save itemindex
  SavedItemIndex := AListView.ItemIndex;

  // Begin update
  AListView.Items.BeginUpdate;

  // Clear the Listview lines
  AListView.Items.Clear;
  // Dynamically create few lines lines
  for IndexLines := 1 to 10 do
  begin
    AListView.AddItem('line ' + IntToStr(IndexLines), nil);
  end;
  // restore ItemIndex
  AListView.ItemIndex := SavedItemIndex;

  // End update
  AListView.Items.EndUpdate;
end;

end.
